package de._82grfl1bif.KPI_Visualizer.commands;

import de._82grfl1bif.KPI_Visualizer.data.DataHolder;
import de._82grfl1bif.KPI_Visualizer.structures.Building;
import de._82grfl1bif.KPI_Visualizer.structures.Foundation;
import de._82grfl1bif.KPI_Visualizer.structures.Structure;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.Server;
import org.bukkit.block.Block;
import org.bukkit.command.Command;
import org.bukkit.command.CommandExecutor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;
import org.jetbrains.annotations.NotNull;

public class generateLayout implements CommandExecutor {

    @Override
    public boolean onCommand(@NotNull CommandSender sender, @NotNull Command command, @NotNull String label, @NotNull String[] args) {
        sender.sendMessage("generating Layout");
        Server server = sender.getServer();
        Player player = server.getPlayer(sender.getName());
        Location location = player.getLocation();

        BukkitRunnable t = new BukkitRunnable() {
            @Override
            public void run() {
                DataHolder.ComplexData();
                DataHolder.foundation.setLocation(location);
                DataHolder.foundation.organizeFoundation();
                DataHolder.foundation.correctAllLocations(location);
                setFoundation(server, DataHolder.foundation.getLocation().clone().add(0, DataHolder.foundation.getDepth(), 0), DataHolder.foundation.getWidth().x, DataHolder.foundation.getWidth().x, DataHolder.foundation.getMaterial());
                setAllChildren(server, DataHolder.foundation);
            }
        };
        t.run();
        return true;
    }

    private void setFoundation(Server server, Location startLocation, int x, int z, Material material) {
        for (int cx = 0; cx < x; cx++) {
            for (int cz = 0; cz < z; cz++) {
                Block block = server.getWorlds().get(0).getBlockAt(startLocation.clone().add(cx, 0, cz));
                block.setType(material);
            }
        }
    }

    private void buildBuilding(Server server, Location startLocation, int x, int y, Material material) {
        setWalls(server, startLocation.clone().add(0, 1, 0), x, y, material);
    }

    private void setWalls(Server server, Location startLocation, int x, int y,Material material) {
        Location save = startLocation.clone();
        Location temp = startLocation.clone();
        for (int cx = 0; cx < x - 1; cx++) {// x+x Wall
            for (int cy = 0; cy < y; cy++) {
                server.getWorlds().get(0).getBlockAt(temp.clone().add(cx,cy,1)).setType(material);
            }
        }
        temp = save.clone();
        for (int cz = 0; cz < x - 1; cz++) {// z+x Wall
            for (int cy = 0; cy < y; cy++) {
                server.getWorlds().get(0).getBlockAt(temp.clone().add(1, cy, cz)).setType(material);
            }
        }
        temp = save.clone().add(0, 0, x - 1);
        for (int cx = 0; cx < x; cx++) {// x+x z+x Wall from x+x
            for (int cy = 0; cy < y; cy++) {
                server.getWorlds().get(0).getBlockAt(temp.clone().add(cx, cy, -1)).setType(material);
            }
        }
        temp = save.clone().add(x - 1, 0, 0);
        for (int cz = 0; cz < x - 1; cz++) {// x+x z+x Wall from x+z
            for (int cy = 0; cy < y; cy++) {
                server.getWorlds().get(0).getBlockAt(temp.clone().add(-1, cy, cz)).setType(material);
            }
        }

        temp = save.clone();
        for (int cx = 0; cx < x - 1; cx++) {// x+x Wall
            for (int cy = 0; cy < y; cy++) {
                server.getWorlds().get(0).getBlockAt(temp.clone().add(cx, cy, 0)).setType(Material.GLASS);
            }
        }
        temp = save.clone();
        for (int cz = 0; cz < x - 1; cz++) {// z+x Wall
            for (int cy = 0; cy < y; cy++) {
                server.getWorlds().get(0).getBlockAt(temp.clone().add(0, cy, cz)).setType(Material.GLASS);
            }
        }
        temp = save.clone().add(0, 0, x - 1);
        for (int cx = 0; cx < x; cx++) {// x+x z+x Wall from x+x
            for (int cy = 0; cy < y; cy++) {
                server.getWorlds().get(0).getBlockAt(temp.clone().add(cx, cy, 0)).setType(Material.GLASS);
            }
        }
        temp = save.clone().add(x - 1, 0, 0);
        for (int cz = 0; cz < x - 1; cz++) {// x+x z+x Wall from x+z
            for (int cy = 0; cy < y; cy++) {
                server.getWorlds().get(0).getBlockAt(temp.clone().add(0, cy, cz)).setType(Material.GLASS);
            }
        }

        temp = save.clone();
        for (int cy = 0; cy < y; cy++) {
            server.getWorlds().get(0).getBlockAt(temp.clone().add(0, cy, 0)).setType(Material.BLACKSTONE);
        }
        temp = save.clone().add(x - 1, 0, 0);
        for (int cy = 0; cy < y; cy++) {
            server.getWorlds().get(0).getBlockAt(temp.clone().add(0, cy, 0)).setType(Material.BLACKSTONE);
        }
        temp = save.clone().add(0, 0, x - 1);
        for (int cy = 0; cy < y; cy++) {
            server.getWorlds().get(0).getBlockAt(temp.clone().add(0, cy, 0)).setType(Material.BLACKSTONE);
        }
        temp = save.clone().add(x - 1, 0, x - 1);
        for (int cy = 0; cy < y; cy++) {
            server.getWorlds().get(0).getBlockAt(temp.clone().add(0, cy, 0)).setType(Material.BLACKSTONE);
        }

        save.add(0,y,0);//roof
        setFoundation(server,save,x,x,Material.BLACKSTONE);
    }

    private void setAllChildren(Server server, Foundation foundation) {
        for (Structure s : foundation.getChildren()) {
            if (s.getClass() == Foundation.class) {//TODO must be revisited to draw rectangular Foundations
                setFoundation(server, s.getLocation().clone().add(0, s.getDepth(), 0), s.getWidth().x, s.getWidth().x, s.getMaterial());
                setAllChildren(server, (Foundation) s);
            } else {//TODO must be revisited to draw rectangular Buildings
                buildBuilding(server, s.getLocation().clone().add(1, s.getDepth(), 1), s.getWidth().x - 2, ((Building) s).getHeight(), s.getMaterial());
            }
        }
    }

}
